Draft WireToBSpline: Difference between revisions

From FreeCAD Documentation
m (Changed section to 'Usage')
No edit summary
(6 intermediate revisions by 3 users not shown)
Line 4: Line 4:
{{Docnav
{{Docnav
|[[Draft_SubelementHighlight|Subelement highlight]]
|[[Draft_SubelementHighlight|Subelement highlight]]
|[[Draft_AddPoint|Add point]]|[[Draft_Module|Draft]]
|[[Draft_AddPoint|Add point]]
|[[Draft_Module|Draft]]
|IconL=Draft_SubelementHighlight.svg
|IconL=Draft_SubelementHighlight.svg
|IconC=Workbench_Draft.svg
|IconR=Draft_AddPoint.svg
|IconR=Draft_AddPoint.svg
|IconC=Workbench_Draft.svg
}}
}}


Line 14: Line 15:
|Name=Draft WireToBSpline
|Name=Draft WireToBSpline
|MenuLocation=Drafting → Wire to BSpline
|MenuLocation=Drafting → Wire to BSpline
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|Workbenches=[[Draft_Module|Draft]], [[Arch_Module|Arch]]
|SeeAlso=[[Draft Wire|Draft Wire]], [[Draft BSpline|Draft BSpline]]
|SeeAlso=[[Draft_Wire|Draft Wire]], [[Draft_BSpline|Draft BSpline]]
}}
}}


Line 21: Line 22:


<!--T:3-->
<!--T:3-->
This tool converts [[Draft Wire|Draft Wires]] to [[Draft BSpline|Draft BSplines]], and vice-versa.
The {{Button|[[Image:Draft WireToBSpline.svg|16px]] [[Draft_WireToBSpline|Draft WireToBSpline]]}} tool converts {{Button|[[Image:Draft_Wire.svg|16px]] [[Draft_Wire|Draft Wires]]}} to {{Button|[[Image:Draft_BSpline.svg|16px]] [[Draft_BSpline|Draft BSplines]]}}, and vice-versa.


</translate>
</translate>
Line 27: Line 28:
<translate>
<translate>
<!--T:12-->
<!--T:12-->
{{Caption|Convertir a wire to a B-Spline, and a closed B-Spline to a closed wire}}
{{Caption|Convert a wire to a B-Spline, and a closed B-Spline to a closed wire}}


==Usage== <!--T:4-->
==Usage== <!--T:4-->
Line 39: Line 40:


<!--T:14-->
<!--T:14-->
{{Emphasis|Note:}} if a closed wire with sharp edges is used to create a spline, the new object may have self intersecting curve segments, and may not be visible in the 3D view. If this is the case, manually set {{PropertyData|Make Face}} to {{FALSE}} to see the new shape, or set {{PropertyData|Closed}} to {{FALSE}} to create an open shape.
{{Emphasis|Note:}} if a closed wire with sharp edges is used to create a spline, the new object may have self intersecting curve segments, and may not be visible in the [[3D view]]. If this is the case, manually set {{PropertyData|Make Face}} to {{FALSE}} to see the new shape, or set {{PropertyData|Closed}} to {{FALSE}} to create an open shape.


==Options== <!--T:6-->
==Options== <!--T:6-->
Line 57: Line 58:
<!--T:10-->
<!--T:10-->
Example:
Example:

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 86: Line 88:
|[[Draft_Module|Draft]]
|[[Draft_Module|Draft]]
|IconL=Draft_SubelementHighlight.svg
|IconL=Draft_SubelementHighlight.svg
|IconR=Draft_AddPoint.svg
|IconC=Workbench_Draft.svg
|IconC=Workbench_Draft.svg
|IconR=Draft_AddPoint.svg
}}
}}


<!--T:18-->
{{Draft Tools navi}}

<!--T:19-->
{{Userdocnavi}}
</translate>
</translate>
{{clear}}
{{clear}}
{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Revision as of 16:07, 29 November 2020

Draft WireToBSpline

Menu location
Drafting → Wire to BSpline
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
-
See also
Draft Wire, Draft BSpline

Description

The Draft WireToBSpline tool converts Draft Wires to Draft BSplines, and vice-versa.

Convert a wire to a B-Spline, and a closed B-Spline to a closed wire

Usage

  1. Select a Draft Wire or a Draft BSpline. The tool is disabled if no object is selected.
  2. Press the Draft WireToBSpline button.

A new object will be created; the original object will not be modified.

Note: if a closed wire with sharp edges is used to create a spline, the new object may have self intersecting curve segments, and may not be visible in the 3D view. If this is the case, manually set DataMake Face to false to see the new shape, or set DataClosed to false to create an open shape.

Options

There are no options for this tool. Either it works with the selected object or not.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

There is no programming interface available for the WireToBSpline tool; however, creating a new object from the points of another is simple.

The Points attribute of an object is a list with the points that comprise that object; this list can be passed to functions that build geometry. Each point is defined by its FreeCAD.Vector, with units in millimeters.

Example:

import FreeCAD, Draft

# Make a spline from the points of a wire
p1 = FreeCAD.Vector(1000, 1000, 0)
p2 = FreeCAD.Vector(2000, 1000, 0)
p3 = FreeCAD.Vector(2500, -1000, 0)
p4 = FreeCAD.Vector(3500, -500, 0)

base_wire = Draft.makeWire([p1, p2, p3, p4])

points1 = base_wire.Points
spline = Draft.makeBSpline(points1)

# Make a wire from the points of a spline
base_spline = Draft.makeBSpline([-p1, -1.3*p2, -1.2*p3, -2.1*p4])

points2 = base_spline.Points
Wire = Draft.makeWire(points2)